package org.neodatis.odb.core.transaction;

import java.util.Observer;

import org.neodatis.odb.OID;
import org.neodatis.odb.core.layers.layer2.meta.MetaModel;
import org.neodatis.odb.core.layers.layer2.meta.ObjectInfoHeader;
import org.neodatis.odb.core.layers.layer3.IStorageEngine;
import org.neodatis.odb.core.layers.layer3.engine.IFileSystemInterface;

public interface ISession extends Observer{

	public abstract ICache getCache();

	public abstract ITmpCache getTmpCache();

	public abstract void rollback();

	public abstract void close();

	public abstract void clearCache();

	public abstract boolean isRollbacked();

	public abstract void clear();

	public abstract IStorageEngine getStorageEngine();

	public abstract boolean transactionIsPending();

	public abstract void commit();

	public abstract ITransaction getTransaction();

	public abstract void setFileSystemInterfaceToApplyTransaction(IFileSystemInterface fsi);

	public abstract String getBaseIdentification();

	public abstract MetaModel getMetaModel();
	public abstract void setMetaModel(MetaModel metaModel2);

	public String getId();
	public void setId(String id);

	public abstract void removeObjectFromCache(Object object);

	/**
	 * Add these information on a session cache.
	 * @param oid. This parameter can not be <code> null </code>
	 * @param object. This parameter can not be <code> null </code>
	 * @param oih. This parameter can not be <code> null </code>
	 */
	public abstract void addObjectToCache(OID oid, Object object, ObjectInfoHeader oih); 

}