//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

package net.ajaest.lib.string;

import java.util.LinkedList;

/**
 * This class consists exclusively of static methods that operate on or return
 * strings.
 * 
 * @author Luis Alfonso Arce González
 * 
 */
public class Strings {

	public static LinkedList<Character> toCharacters(String s) {
		LinkedList<Character> chars = new LinkedList<Character>();
		for (Character c : s.toCharArray())
			chars.add(c);
		return chars;
	}

	public static String fillHead(String s, char c, int i) {

		StringBuilder strb = new StringBuilder();

		for (int j = 0; j < i; j++) {
			strb.append(c);
		}

		strb.append(s);

		return strb.toString();
	}

	public static String fillTail(String s, char c, int i) {

		StringBuilder strb = new StringBuilder(s);

		for (int j = 0; j < i; j++) {
			strb.append(c);
		}

		return strb.toString();
	}

	public static String trimToDecimalNumeric(String s) {

		StringBuilder sb = new StringBuilder();
		char[] charArray = s.toCharArray();
		int i = 0;

		if (charArray.length > 1 && charArray[0] == '-' && Character.isDigit(charArray[1])) {
			sb.append('-');
			sb.append(charArray[1]);
			i = 2;
		}

		if (charArray.length > 0) {
			for (; i < charArray.length; i++) {
				if (Character.isDigit(charArray[i]))
					sb.append(charArray[i]);
			}
		}

		return sb.toString();
	}
}
