//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

package net.ajaest.lib.swing.util;

import java.util.List;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

import net.ajaest.lib.locale.SwingMessages;
import net.ajaest.lib.locale.SwingMessagesEnums.ContextMenuEnums;
import net.ajaest.lib.swing.util.action.JLabelMultiCopyAction;
import net.ajaest.lib.utils.SystemEnums.ISO639ー1;

//TODO: JavaDoc
public class SWINGComponentFactory {

	public static CreatePopMenu createJPopMenu(ISO639ー1 lang) {

		return new CreatePopMenu(lang);
	}

	public static class CreatePopMenu {

		private ISO639ー1 lang;

		private CreatePopMenu(ISO639ー1 lan) {
			lang = lan;
		}

		public JPopupMenu createLabelMultiCopyPopMenu(JComponent c, List<JLabel> textsC, String delimiter) {

			JLabelMultiCopyAction mca = new JLabelMultiCopyAction(textsC, delimiter);
			
			JPopupMenu jpm = new JPopupMenu();
			JMenuItem jmi = new JMenuItem(mca);
			jmi.setText(SwingMessages.getLocalizedMessages(lang).getContextMenuEditMessages().get(ContextMenuEnums.editMenu.COPY));

			return jpm;
		}
	}

}
