//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

package net.ajaest.lib.swing.util.action;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.util.List;

import javax.swing.AbstractAction;
import javax.swing.JLabel;

//TODO: JavaDoc
public class JLabelMultiCopyAction extends AbstractAction {

	private String delimiter = "\r\n";

	private List<JLabel> components;

	public JLabelMultiCopyAction(List<JLabel> textsC, String delimiter) {

		if (delimiter != null && !delimiter.equals(""))
			this.delimiter = delimiter;
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = -3324246157367636384L;

	@Override
	public void actionPerformed(ActionEvent e) {

		StringBuilder copied = new StringBuilder();

		for (int i = 0; i < components.size() - 1; i++) {
			copied.append(components.get(i).getText());
			copied.append(delimiter);
		}

		if (components.size() > 0)
			copied.append(components.get(components.size() - 1).getText());

		StringSelection copiedSel = new StringSelection(copied.toString());
		Clipboard cp = Toolkit.getDefaultToolkit().getSystemClipboard();
		cp.setContents(copiedSel, copiedSel);

	}

	

}
