//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

package net.ajaest.lib.util.mac;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JTextArea;

/**
 * Workaround to launch Java apps linking in mac OS. Legacy is not tested, only
 * in mac book pro 15' 2010
 * 
 * An ".class" binary of this class must be in the
 * "Contents/Resources/Java/net/ajaest/lib/util/mac/" folder of the
 * "whatever.app" file system. The launcher is made using mac jar bundler
 * choosing as Main class this class and passing as unique argument the name of
 * the jar jar file to launch in "whatever.app/.." folder.
 * 
 * @author Luis Alfonso Arce González
 * 
 */
public class MacJarLauncher {

	/**
	 * 
	 * @param args
	 *            argument is jar name to load
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	public static void main(String... args) throws FileNotFoundException,
			IOException {

		URL dir = MacJarLauncher.class.getResource("MacJarLauncher.class");

		String currentFile = dir.getFile().replace("Contents/Resources/Java/net/ajaest/lib/util/mac/MacJarLauncher.class", "");

		currentFile = URLDecoder.decode(currentFile, "UTF-8");

		// don't know launcher name and arguments
		File f = new File(currentFile);
		currentFile = f.getParent();

		List<String> comArgs = new ArrayList<String>();

		for (String s : args)
			Collections.addAll(comArgs, s.split(" "));

		Process p1 = Runtime.getRuntime().exec((String[]) comArgs.toArray());

		BufferedReader input = new BufferedReader(new InputStreamReader(p1
				.getErrorStream()));

		String result = "";

		String line;
		while ((line = input.readLine()) != null) {
			result += line + "\n";
		}

		input.close();

		if (result.length() > 0) {

			JFrame jf = new JFrame("Error when launching");
			jf.add(new JTextArea(currentFile + "\n" + comArgs.toArray()
					+ "\n**************\n" + result));
			jf.setSize(400, 200);
			jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			jf.setVisible(true);
		}

	}
}
